/**
 * name: use-spotlight@1.0.10
 * desc: A react hook that generates an animated 'spotlight' follows the active target.
 * author: 9am <tech.9am@gmail.com> [https://9am.github.io/]
 * homepage: https://github.com/9am/use-spotlight#readme
 * license: MIT
 */
import { useState as C, useRef as M, useCallback as N, useEffect as $, useInsertionEffect as U } from "react";
var j = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function V(t) {
  return t && t.__esModule && Object.prototype.hasOwnProperty.call(t, "default") ? t.default : t;
}
var W = "Expected a function", _ = 0 / 0, G = "[object Symbol]", X = /^\s+|\s+$/g, Y = /^[-+]0x[0-9a-f]+$/i, Z = /^0b[01]+$/i, H = /^0o[0-7]+$/i, q = parseInt, J = typeof j == "object" && j && j.Object === Object && j, K = typeof self == "object" && self && self.Object === Object && self, Q = J || K || Function("return this")(), tt = Object.prototype, et = tt.toString, nt = Math.max, rt = Math.min, w = function() {
  return Q.Date.now();
};
function it(t, e, n) {
  var o, a, p, l, c, d, u = 0, T = !1, h = !1, m = !0;
  if (typeof t != "function")
    throw new TypeError(W);
  e = P(e) || 0, L(n) && (T = !!n.leading, h = "maxWait" in n, p = h ? nt(P(n.maxWait) || 0, e) : p, m = "trailing" in n ? !!n.trailing : m);
  function S(r) {
    var y = o, E = a;
    return o = a = void 0, u = r, l = t.apply(E, y), l;
  }
  function O(r) {
    return u = r, c = setTimeout(s, e), T ? S(r) : l;
  }
  function i(r) {
    var y = r - d, E = r - u, A = e - y;
    return h ? rt(A, p - E) : A;
  }
  function b(r) {
    var y = r - d, E = r - u;
    return d === void 0 || y >= e || y < 0 || h && E >= p;
  }
  function s() {
    var r = w();
    if (b(r))
      return f(r);
    c = setTimeout(s, i(r));
  }
  function f(r) {
    return c = void 0, m && o ? S(r) : (o = a = void 0, l);
  }
  function g() {
    c !== void 0 && clearTimeout(c), u = 0, o = d = a = c = void 0;
  }
  function v() {
    return c === void 0 ? l : f(w());
  }
  function x() {
    var r = w(), y = b(r);
    if (o = arguments, a = this, d = r, y) {
      if (c === void 0)
        return O(d);
      if (h)
        return c = setTimeout(s, e), S(d);
    }
    return c === void 0 && (c = setTimeout(s, e)), l;
  }
  return x.cancel = g, x.flush = v, x;
}
function ot(t, e, n) {
  var o = !0, a = !0;
  if (typeof t != "function")
    throw new TypeError(W);
  return L(n) && (o = "leading" in n ? !!n.leading : o, a = "trailing" in n ? !!n.trailing : a), it(t, e, {
    leading: o,
    maxWait: e,
    trailing: a
  });
}
function L(t) {
  var e = typeof t;
  return !!t && (e == "object" || e == "function");
}
function st(t) {
  return !!t && typeof t == "object";
}
function at(t) {
  return typeof t == "symbol" || st(t) && et.call(t) == G;
}
function P(t) {
  if (typeof t == "number")
    return t;
  if (at(t))
    return _;
  if (L(t)) {
    var e = typeof t.valueOf == "function" ? t.valueOf() : t;
    t = L(e) ? e + "" : e;
  }
  if (typeof t != "string")
    return t === 0 ? t : +t;
  t = t.replace(X, "");
  var n = Z.test(t);
  return n || H.test(t) ? q(t.slice(2), n ? 2 : 8) : Y.test(t) ? _ : +t;
}
var ct = ot;
const lt = /* @__PURE__ */ V(ct), z = [0, 0, 0, 0], R = { x: 0, y: 0, width: 0, height: 0 }, ut = {
  throttleWait: 0,
  stageBorderEdge: !1,
  stageMutation: !1,
  lightPseudo: null
}, k = {
  content: '""',
  display: "block",
  boxSizing: "border-box",
  position: "absolute",
  top: "0px",
  left: "0px",
  width: "var(--spotlight-w)",
  height: "var(--spotlight-h)",
  transform: "translate(var(--spotlight-x), var(--spotlight-y))",
  transitionProperty: "transform, width, height",
  transitionDuration: "var(--spotlight-duration, 200ms)",
  background: "var(--spotlight-bg, rgba(255, 0, 0, 0.1))",
  pointerEvents: "none",
  zIndex: "999",
  padding: "0px",
  margin: "0px",
  overflow: "hidden"
}, ft = Object.keys(k).reduce((t, e) => {
  const n = e.replace(/([A-Z])/, "-$1").toLowerCase(), o = k[e];
  return `${t}${n}:${o};`;
}, ""), I = "spotlight-stage", dt = U ?? $, B = (t, e) => {
  var n;
  try {
    return +(((n = getComputedStyle(t, null)) == null ? void 0 : n.getPropertyValue(e)) ?? "").replace("px", "");
  } catch {
    return 0;
  }
}, D = (t, e) => {
  const n = (t == null ? void 0 : t.getBoundingClientRect()) ?? R, o = e ? B(t, "border-left-width") : 0, a = e ? B(t, "border-top-width") : 0;
  return {
    ...n,
    x: n.x - ((t == null ? void 0 : t.scrollLeft) ?? 0) + o,
    y: n.y - ((t == null ? void 0 : t.scrollTop) ?? 0) + a
  };
}, F = ([t, e, n, o]) => ({
  "--spotlight-x": `${t}px`,
  "--spotlight-y": `${e}px`,
  "--spotlight-w": `${n}px`,
  "--spotlight-h": `${o}px`
}), pt = (t) => {
  const { throttleWait: e, stageBorderEdge: n, stageMutation: o, lightPseudo: a } = {
    ...ut,
    ...t
  }, [p, l] = C(z), [c, d] = C(R), [u, T] = C(R);
  let h = M(null), m = M(null);
  const S = N(
    (i) => {
      h.current = i, d(i ? D(i, n) : R);
    },
    [d, n]
  ), O = N(
    (i) => {
      m.current = i, T((i == null ? void 0 : i.getBoundingClientRect()) ?? R);
    },
    [T]
  );
  return $(() => {
    l([
      u.x - c.x,
      u.y - c.y,
      u.width,
      u.height
    ]);
  }, [c, u, l]), $(() => {
    const i = h.current, b = m.current;
    if (!i || !b)
      return () => l(z);
    let s = null, f = null;
    const g = lt(() => {
      const x = D(i, n), r = b.getBoundingClientRect();
      l([r.x - x.x, r.y - x.y, r.width, r.height]);
    }, e), v = () => {
      g();
    };
    return typeof ResizeObserver < "u" && (s = new ResizeObserver(g), s.observe(i), s.observe(b)), typeof MutationObserver < "u" && (f = new MutationObserver(v), o && f.observe(i, {
      subtree: !0,
      childList: !0
    }), f.observe(b, {
      subtree: !0,
      childList: !0,
      characterData: !0
    })), () => {
      s == null || s.disconnect(), f == null || f.disconnect();
    };
  }, [c, u, l, e, n, o]), dt(() => {
    var f;
    const i = h.current;
    if (!i)
      return () => {
      };
    const b = i.style.position;
    i.style.position = "relative";
    let s = null;
    if (a && typeof document < "u") {
      s = document.createElement("style"), s.textContent = `.${I}${a} {${ft}}`, (f = document.head) == null || f.appendChild(s), i.classList.add(I);
      const g = F(p);
      Object.keys(g).forEach(
        (v) => i.style.setProperty(v, g[v])
      );
    }
    return () => {
      var g;
      i.style.position = b, a && typeof document < "u" && (i.classList.remove(I), s && ((g = document.head) == null || g.removeChild(s)));
    };
  }, [p, a]), {
    stage: S,
    actor: O,
    style: { ...F(p), ...k },
    size: p
  };
}, ht = null;
export {
  ht as default,
  pt as useSpotlight
};
