import type { RefCallback } from 'react';

declare const _default: null;
export default _default;

export declare type Size = [number, number, number, number];

export declare type Spotlight = {
    stage: RefCallback<any>;
    actor: RefCallback<any>;
    style: Style;
    size: Size;
};

export declare type SpotlightOptions = {
    throttleWait?: number;
    stageBorderEdge?: boolean;
    stageMutation?: boolean;
    lightPseudo?: '::before' | '::after' | null;
};

export declare type Style = {
    [key: string]: string;
};

export declare const useSpotlight: (options?: SpotlightOptions) => Spotlight;

export { }
